image: registry.gitlab.com/aegis-techno/continuous-integration/docker-images/debian-ng:latest

variables:
    NG_PROJECT_NAME: "web-app"

include:
    -   project: 'aegis-techno/continuous-integration/ci-scripts'
        ref: master
        file: 'pipelines/angular-app.yaml'
    -   project: 'aegis-techno/continuous-integration/ci-scripts'
        ref: master
        file: 'pipelines/docker.yaml'
    -   project: 'aegis-techno/continuous-integration/ci-scripts'
        ref: master
        file: 'pipelines/merge-request.yaml'

stages:
    - prepare
    - test-quality
    - build
    - build-image
    - publish
    - merge-request

prepare:app:
    stage: prepare
    extends: .prepare

lint:app:
    stage: test-quality
    needs:
      - prepare:app
    extends: .lint

test:app:
    stage: test-quality
    needs:
      - prepare:app
    extends: .test

e2e:app:
    stage: test-quality
    needs:
      - prepare:app
    extends: .e2e:cypress

build:app:
    stage: build
    needs:
      - prepare:app
    extends: .build

docker:build:
    stage: build-image
    extends: .docker:build

docker:release:
    stage: publish
    needs:
      - docker:build
    extends: .docker:release

merge_request:develop_to_master:
    stage: merge-request
    extends: .develop_to_master

merge_request:master_to_develop:
    stage: merge-request
    extends: .master_to_develop

merge_request:master_to_release:
    stage: merge-request
    extends: .master_to_release

merge_request:release_to_master:
    stage: merge-request
    extends: .release_to_master